#include <stdio.h>
#define FO fprintf(fo

int ICSLogo(FILE * fo) {
  FO,"%% set scale external to this routine\n");
  FO,"/ICSLogo_w { 222 } def\n");
  FO,"/ICSLogo_h { 168 } def\n");
  FO,"/ICSLogo {      %% on stack : \n");
  FO,"  /M { moveto } def\n");
  FO,"  /L { lineto } def\n");
  FO,"  /RL { rlineto } def\n");
  FO,"  /RM { rmoveto } def\n");
  FO,"  /GS { gsave } def\n");
  FO,"  /GR { grestore } def\n");
  FO,"  /NP { newpath } def\n");
  FO,"  /CP { closepath } def\n");
  FO,"\n");
  FO,"  GS currentpoint translate   %% translate to currentpoint\n");
  FO,"  /LineWidth 4 def\n");
  FO,"\n");
  FO,"  %% setup clippath for arcs\n");
  FO,"  %% need to draw arcs first to cover up ends with blank boxes for island\n");
  FO,"  GS 0 30 translate 1 setlinewidth\n");
  FO,"  /LogoClipBox0 { NP 72 141 M 222 140 L 222 -30 L 140 -30 L CP } def\n");
  FO,"  LogoClipBox0 clip\n");
  FO,"\n");
  FO,"  %% draw arcs and then restore graphics state\n");
  FO,"  %% top arc\n");
  FO,"  LineWidth setlinewidth NP 155 40 88 0 180 arc stroke\n");
  FO,"\n");
  FO,"  %%bottom arc\n");
  FO,"  LineWidth setlinewidth NP 165 -10 85 0 180 arc stroke\n");
  FO,"  GR\n");
  FO,"\n");
  FO,"  %% draw some blank boxes over ends of arcs for island (this is a hack)\n");
  FO,"  %% start at right edge of box\n");
  FO,"  GS NP 0 30 translate\n");
  FO,"  %%222 140 M 222 -30 L 300 -30 L 300 140 L CP 1 setgray fill GR\n");
  FO,"  /LogoClipBox1 { NP 220 140 M 0 -150 RL 18 0 RL 0 150 RL CP } def\n");
  FO,"  LogoClipBox1 1 setgray fill\n");
  FO,"  %%LogoClipBox1 stroke\n");
  FO,"  GR\n");
  FO,"\n");
  FO,"  GS NP 0 30 translate\n");
  FO,"  %%72 141 M 140 -30 L 0 -30 L 0 140 L CP 1 setgray fill GR\n");
  FO,"  /LogoClipBox2 { NP 72 141 M 58 -140 RL -100 0 RL 0 140 RL CP } def\n");
  FO,"  LogoClipBox2 1 setgray fill\n");
  FO,"  %%LogoClipBox2 stroke \n");
  FO,"  GR\n");
  FO,"\n");
  FO,"  %% do the UCSB portion of it\n");
  FO,"  /Helvetica-Bold findfont 29 scalefont setfont\n");
  FO,"  GS NP 139 15 M\n");
  FO,"  1 .9 scale 2 setlinewidth\n");
  FO,"  GS (UC) true charpath stroke GR (UC) show\n");
  FO,"  1 0 RM         %% add one pixel in here for alignment\n");
  FO,"  GS (SB) true charpath stroke GR (SB) show\n");
  FO,"  GR\n");
  FO,"  \n");
  FO,"  %% do the ICS bottom string\n");
  FO,"  /Helvetica-Bold findfont 12.8 scalefont setfont\n");
  FO,"  0 0 M (INSTITUTE FOR CRUSTAL STUDIES) show\n");
  FO,"\n");
  FO,"  %% translate to lower left-hand corner of lefthand box\n");
  FO,"  0 30 translate LineWidth setlinewidth\n");
  FO,"\n");
  FO,"  %% draw small epicenter circle then larger\n");
  FO,"  NP 110 50 15 0 360 arc stroke\n");
  FO,"  NP 110 50 35 0 360 arc stroke\n");
  FO,"\n");
  FO,"  %% draw lefthand box\n");
  FO,"  %% start with top of angled line\n");
  FO,"  NP 90 100 M 130 0 L 0 0 L 0 90 L 95 90 L stroke\n");
  FO,"\n");
  FO,"  %% middle straight line\n");
  FO,"  NP 0 45 M 111 0 RL stroke\n");
  FO,"  \n");
  FO,"  %%  draw right hand box\n");
  FO,"  NP 127 10 M 220 10 L 220 100 L stroke\n");
  FO,"\n");
  FO,"  /ICSLogo_I {                   %% stack : cx cy hh\n");
  FO,"     /hh exch def /nh { hh -1 mul } def /cy exch def /cx exch def\n");
  FO,"     GS cx cy translate NP -7 nh M -7 hh L 7 hh L 7 nh L CP fill GR\n");
  FO,"     } def\n");
  FO,"  /ICSLogo_C {                   %% stack : cx cy hh\n");
  FO,"     /hh exch def /nh { hh -1 mul } def /cy exch def /cx exch def\n");
  FO,"     GS cx cy translate NP 0 0 hh 90 270 arc CP fill NP\n");
  FO,"     %% start lower tip\n");
  FO,"     1 nh M 12 0 RL 0 15 RL CP fill\n");
  FO,"     %% start upper tip\n");
  FO,"     NP 1 hh M 12 0 RL 0 -15 RL CP fill \n");
  FO,"     GR } def\n");
  FO,"  /ICSLogo_S {                   %% stack : cx cy hh\n");
  FO,"     /hh exch def /nh { hh -1 mul } def /cy exch def /cx exch def\n");
  FO,"     /smallrad 2 def /largerad 10 def\n");
  FO,"     GS cx cy translate NP 2 nh M\n");
  FO,"     25 nh 0 12 largerad arcto 4 {pop} repeat\n");
  FO,"     -5 hh -2 hh smallrad arcto 4 {pop} repeat\n");
  FO,"     -26 hh 0 -12 largerad arcto 4 {pop} repeat\n");
  FO,"     5 nh 2 nh smallrad arcto 4 {pop} repeat\n");
  FO,"     CP fill\n");
  FO,"     NP 0 nh M -15 0 RL 0 20 RL CP fill   %% lower tip of S\n");
  FO,"     NP 0 hh M 15 0 RL 0 -20 RL CP fill   %% upper tip of S\n");
  FO,"     GR } def\n");
  FO,"  \n");
  FO,"  %% plot the ICS label using defined procedures\n");
  FO,"   7 115 20 ICSLogo_I\n");
  FO,"  36 115 20 ICSLogo_C\n");
  FO,"  68 115 20 ICSLogo_S\n");
  FO,"  GR\n");
  FO,"} def    %% end ICSLogo\n");
  FO,"\n");
  FO,"/ICSLogo_scxy {    %% on stack: xscale yscale x y\n");
  FO,"  gsave moveto scale ICSLogo grestore\n");
  FO,"  } def\n");
  FO,"\n");
} /* end proc ICSLogo */
