#!/bin/sh
# Program: respname
# Tcl version: 7.3 (Tcl/Tk/XF)
# Tk version: 3.6
# XF version: $__lastrelease$

# fire off pdbwish \
exec pdbwish95 -f $0 $*

# module inclusion
global env
global xfLoadPath
if {[info exists env(XF_LOAD_PATH)]} {
  if {[string first $env(XF_LOAD_PATH) .:/local/ucsb/response/tcl:.:/local/tcl/lib:/usr/local/lib/] == -1} {
    set xfLoadPath $env(XF_LOAD_PATH):.:/local/ucsb/response/tcl:.:/local/tcl/lib:/usr/local/lib/
  } {
    set xfLoadPath .:/local/ucsb/response/tcl:.:/local/tcl/lib:/usr/local/lib/
  }
} {
  set xfLoadPath .:/local/ucsb/response/tcl:.:/local/tcl/lib:/usr/local/lib/
}

global argc
global argv
global tkVersion
global xfLoadInfo
global xfLoadPath
set xfLoadInfo 0
set tmpArgv ""
for {set counter 0} {$counter < $argc} {incr counter 1} {
  case [string tolower [lindex $argv $counter]] in {
    {-xfloadpath} {
      incr counter 1
      set xfLoadPath "[lindex $argv $counter]:$xfLoadPath"
    }
    {-xfstartup} {
      incr counter 1
      source [lindex $argv $counter]
    }
    {-xfbindfile} {
      incr counter 1
      set env(XF_BIND_FILE) "[lindex $argv $counter]"
    }
    {-xfcolorfile} {
      incr counter 1
      set env(XF_COLOR_FILE) "[lindex $argv $counter]"
    }
    {-xfcursorfile} {
      incr counter 1
      set env(XF_CURSOR_FILE) "[lindex $argv $counter]"
    }
    {-xffontfile} {
      incr counter 1
      set env(XF_FONT_FILE) "[lindex $argv $counter]"
    }
    {-xfmodelmono} {
      if {$tkVersion >= 3.0} {
        tk colormodel . monochrome
      }
    }
    {-xfmodelcolor} {
      if {$tkVersion >= 3.0} {
        tk colormodel . color
      }
    }
    {-xfloading} {
      set xfLoadInfo 1
    }
    {-xfnoloading} {
      set xfLoadInfo 0
    }
    {default} {
      lappend tmpArgv [lindex $argv $counter]
    }
  }
}
set argv $tmpArgv
set argc [llength $tmpArgv]
unset counter
unset tmpArgv


# procedure to show window .top0
proc ShowWindow.top0 {args} {# xf ignore me 7

  # build widget .top0
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top0"
  } {
    catch "destroy .top0"
  }
  toplevel .top0 

  # Window manager configurations
  global tkVersion
  wm positionfrom .top0 ""
  wm sizefrom .top0 ""
  wm maxsize .top0 1000 1000
  wm minsize .top0 10 10
  wm title .top0 {Respname Help}


  # build widget .top0.button2
  button .top0.button2 \
    -command {help_done}\
    -text {Done}

  # build widget .top0.message1
  message .top0.message1 \
    -aspect {1038}\
    -borderwidth {0}\
    -padx {5}\
    -pady {2}\
    -relief {sunken}\
    -text {Respname is a tool designed to generate the linking list for 
response processing.  Normally it is run from respproc. The 
top line of the Respname tool is a menubar containing possible
field presets.  These presets can be used to avoid typing in all
values.  The line below that is a message line.  This line 
is used to pass messages to the user.  In particular it is 
used to display errors. 

Respname is comprised of a series of fields.  Most of these 
fields are expected to have either a single entry common to all
sensor sets or a sequence of space separated entries that correspond
to each sensor set.  

The following fields accept multiple, space delimited entries:
  Owner seq
  Model seq
  Serial seq
  Site seq
  Components

The number of lines output will be the number of entries in 
"Serial seq" * the number of entries in "Components".

If this number does not equal the number of files, the user 
will get a message displayed in the message box.

If there are multiple, space delimited entries in the "Site 
seq" field, the number of entries must equal the number 
of entries in "Serial seq".  The same goes for any other 
fields that allow sequences.

Serial prefix is an optional field that is just tacked 
onto the beginning of each entry in the "Serial seq" at 
list generation time.  So a prefix of "G" and "Serial # seq" of 
"1 2 3" will be expanded to "G1 G2 G3" when lnlist is made.

The "Owners ...", "Models ..." and "Components ..."
buttons all contain possible presets.}

  # pack widget .top0
  pack append .top0 \
    .top0.message1 {top frame n fillx} \
    .top0.button2 {bottom frame s fillx} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top0
  }
}

proc DestroyWindow.top0 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top0]" != ""} {
      global xfShowWindow.top0
      set xfShowWindow.top0 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top0; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top0"
    update
  }
}


# procedure to show window .top1
proc ShowWindow.top1 {args} {# xf ignore me 7

  # build widget .top1
  if {"[info procs XFEdit]" != ""} {
    catch "XFDestroy .top1"
  } {
    catch "destroy .top1"
  }
  toplevel .top1 

  # Window manager configurations
  global tkVersion
  wm positionfrom .top1 ""
  wm sizefrom .top1 ""
  wm maxsize .top1 1000 1000
  wm minsize .top1 10 10
  wm title .top1 {Cleanup Problem Records}


  # build widget .top1.frame3
  frame .top1.frame3 \
    -borderwidth {2}\
    -relief {raised}

  # build widget .top1.frame3.button7
  button .top1.frame3.button7 \
    -text {Remove Selection}\
    -command {remove_prob_record}

  # pack widget .top1.frame3
  pack append .top1.frame3 \
    .top1.frame3.button7 {left frame center expand fillx} 

  # build widget .top1.frame4
  frame .top1.frame4 \
    -borderwidth {2} \
    -relief {raised}

  # build widget .top1.frame4.scrollbar9
  scrollbar .top1.frame4.scrollbar9 \
    -command {.top1.frame4.listbox8 yview}

  # build widget .top1.frame4.listbox8
  listbox .top1.frame4.listbox8 \
    -yscrollcommand {.top1.frame4.scrollbar9 set}\
    -relief {raised}
    # -geometry {10x11}\

  bind .top1.frame4.listbox8 <Button-1> { %W select from [%W nearest %y];set_rm_file [selection get] }

  # pack widget .top1.frame4
  pack append .top1.frame4 \
    .top1.frame4.listbox8 {left frame center expand fillx} \
    .top1.frame4.scrollbar9 {right frame center filly} 

  # build widget .top1.frame5
  frame .top1.frame5 \
    -borderwidth {2}\
    -relief {raised}

  # build widget .top1.frame5.button6
  button .top1.frame5.button6 \
    -command {cleanup_done}\
    -text {Done}

  # pack widget .top1.frame5
  pack append .top1.frame5 \
    .top1.frame5.button6 {top frame w padx 263 expand fillx} 

  # pack widget .top1
  pack append .top1 \
    .top1.frame3 {top frame center fillx} \
    .top1.frame4 {top frame center fillx} \
    .top1.frame5 {top frame center fillx} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .top1
  }
}

proc DestroyWindow.top1 {} {# xf ignore me 7
  if {"[info procs XFEdit]" != ""} {
    if {"[info commands .top1]" != ""} {
      global xfShowWindow.top1
      set xfShowWindow.top1 0
      XFEditSetPath .
      after 200 "XFSaveAsProc .top1; XFEditSetShowWindows"
    }
  } {
    catch "destroy .top1"
    update
  }
}


# procedure to show window .
proc ShowWindow. {args} {# xf ignore me 7

  # Window manager configurations
  global tkVersion
  wm positionfrom . user
  wm sizefrom . ""
  wm maxsize . 1152 900
  wm title . {respname.tcl}

  # bindings
  bind . <B3-Motion> {MenuPopupHandle .menu_fr.menu5 %W %X %Y}
  bind . <Button-3> {.menu_fr.menu5 post %X %Y}
  bind . <ButtonRelease-3> {.menu_fr.menu5 invoke active; .menu_fr.menu5 unpost}

  # build widget .fr_entries
  frame .fr_entries \
    -borderwidth {2}\
    -relief {ridge}\
    -width {400}

  # build widget .fr_entries.fr_comp_seq
  frame .fr_entries.fr_comp_seq \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_comp_seq.e
  entry .fr_entries.fr_comp_seq.e \
    -textvariable {comp_seq}\
    -width {40}

  # build widget .fr_entries.fr_comp_seq.label23
  label .fr_entries.fr_comp_seq.label23 \
    -relief {raised}\
    -text {Components:}

  # pack widget .fr_entries.fr_comp_seq
  pack append .fr_entries.fr_comp_seq \
    .fr_entries.fr_comp_seq.label23 {left frame center} \
    .fr_entries.fr_comp_seq.e {left frame w} 

  # build widget .fr_entries.fr_date
  frame .fr_entries.fr_date \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_date.e
  entry .fr_entries.fr_date.e \
    -textvariable {respname_date} \
    -width {40}

  # build widget .fr_entries.fr_date.label11
  label .fr_entries.fr_date.label11 \
    -relief {raised}\
    -text {Date:}

  # pack widget .fr_entries.fr_date
  pack append .fr_entries.fr_date \
    .fr_entries.fr_date.label11 {left frame w} \
    .fr_entries.fr_date.e {top frame w} 

  # build widget .fr_entries.fr_model
  frame .fr_entries.fr_model \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_model.e
  entry .fr_entries.fr_model.e \
    -textvariable {sens_mod} \
    -width {40}

  # build widget .fr_entries.fr_model.label17
  label .fr_entries.fr_model.label17 \
    -relief {raised}\
    -text {Model seq:}

  # pack widget .fr_entries.fr_model
  pack append .fr_entries.fr_model \
    .fr_entries.fr_model.label17 {left frame e} \
    .fr_entries.fr_model.e {left frame w} 

  # build widget .fr_entries.fr_owner
  frame .fr_entries.fr_owner \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_owner.e
  entry .fr_entries.fr_owner.e \
    -textvariable {sens_own} \
    -width {40}

  # build widget .fr_entries.fr_owner.label15
  label .fr_entries.fr_owner.label15 \
    -relief {raised}\
    -text {Owner seq:}

  # pack widget .fr_entries.fr_owner
  pack append .fr_entries.fr_owner \
    .fr_entries.fr_owner.label15 {left frame center} \
    .fr_entries.fr_owner.e {left frame w} 

  # build widget .fr_entries.fr_sens_pre
  frame .fr_entries.fr_sens_pre \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_sens_pre.e
  entry .fr_entries.fr_sens_pre.e \
    -textvariable {sens_pre} \
    -width {40}

  # build widget .fr_entries.fr_sens_pre.label19
  label .fr_entries.fr_sens_pre.label19 \
    -relief {raised}\
    -text {Serial prefix:}

  # pack widget .fr_entries.fr_sens_pre
  pack append .fr_entries.fr_sens_pre \
    .fr_entries.fr_sens_pre.label19 {left frame center} \
    .fr_entries.fr_sens_pre.e {top frame w} 

  # build widget .fr_entries.fr_ser_seq
  frame .fr_entries.fr_ser_seq \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_ser_seq.e
  entry .fr_entries.fr_ser_seq.e \
    -textvariable {sens_ser_seq} \
    -width {40}

  # build widget .fr_entries.fr_ser_seq.label21
  label .fr_entries.fr_ser_seq.label21 \
    -relief {raised}\
    -text {Serial seq:}

  # pack widget .fr_entries.fr_ser_seq
  pack append .fr_entries.fr_ser_seq \
    .fr_entries.fr_ser_seq.label21 {left frame center} \
    .fr_entries.fr_ser_seq.e {top frame w} 

  # build widget .fr_entries.fr_site_seq
  frame .fr_entries.fr_site_seq \
    -borderwidth {2}\
    -relief {ridge}

  # build widget .fr_entries.fr_site_seq.e
  entry .fr_entries.fr_site_seq.e \
    -textvariable {sens_site_seq} \
    -width {40}

  # build widget .fr_entries.fr_site_seq.label13
  label .fr_entries.fr_site_seq.label13 \
    -relief {raised}\
    -text {Site seq:}

  # pack widget .fr_entries.fr_site_seq
  pack append .fr_entries.fr_site_seq \
    .fr_entries.fr_site_seq.label13 {left frame center} \
    .fr_entries.fr_site_seq.e {top frame w} 

  # pack widget .fr_entries
  pack append .fr_entries \
    .fr_entries.fr_date {top frame center fillx} \
    .fr_entries.fr_owner {top frame center fillx} \
    .fr_entries.fr_model {top frame center fillx} \
    .fr_entries.fr_sens_pre {top frame center fillx} \
    .fr_entries.fr_site_seq {top frame center fillx} \
    .fr_entries.fr_ser_seq {top frame center fillx} \
    .fr_entries.fr_comp_seq {top frame w fillx} 

  # build widget .frame2
  frame .frame2 \
    -relief {raised}
    # -geometry {30x30}\

  # build widget .frame3
  frame .frame3 \
    -borderwidth {2}\
    -relief {raised}

  # build widget .frame3.button0
  button .frame3.button0 \
    -command {quit_respname}\
    -text {Quit}

  # build widget .frame3.button1
  button .frame3.button1 \
    -command {build_lnlist}\
    -text {Build lnlist}

  # build widget .frame3.button10
  button .frame3.button10 \
    -command {cleanup_show}\
    -text {Clean up problem records}

  # build widget .frame3.button2
  button .frame3.button2 \
    -command {help_show}\
    -text {Help}

  # pack widget .frame3
  pack append .frame3 \
    .frame3.button0 {left frame w expand fillx} \
    .frame3.button1 {left frame w} \
    .frame3.button2 {left frame w} \
    .frame3.button10 {left frame center expand fillx} 

  # build widget .menu_fr
  frame .menu_fr \
    -borderwidth {2}\
    -relief {raised}

  # build widget .menu_fr.frame0
  frame .menu_fr.frame0 \
    -relief {raised}

  # build widget .menu_fr.frame0.menubutton1
  menubutton .menu_fr.frame0.menubutton1 \
    -menu {.menu_fr.frame0.menubutton1.m}\
    -text {Owners}

  # build widget .menu_fr.frame0.menubutton1.m
  menu .menu_fr.frame0.menubutton1.m 

  # build widget .menu_fr.frame0.menubutton2
  menubutton .menu_fr.frame0.menubutton2 \
    -menu {.menu_fr.frame0.menubutton2.m}\
    -text {Models}

  # build widget .menu_fr.frame0.menubutton2.m
  menu .menu_fr.frame0.menubutton2.m 

  # build widget .menu_fr.frame0.menubutton3
  menubutton .menu_fr.frame0.menubutton3 \
    -menu {.menu_fr.frame0.menubutton3.m}\
    -text {Components}

  # build widget .menu_fr.frame0.menubutton3.m
  menu .menu_fr.frame0.menubutton3.m 

  # pack widget .menu_fr.frame0
  pack append .menu_fr.frame0 \
    .menu_fr.frame0.menubutton1 {left frame center} \
    .menu_fr.frame0.menubutton2 {left frame center} \
    .menu_fr.frame0.menubutton3 {left frame center} 

  # build widget .menu_fr.message0
  label .menu_fr.message0 \
    -anchor {w}\
    -foreground {VioletRed}\
    -padx {5}\
    -pady {2}\
    -relief {ridge}\
    -text {}\
    -textvariable {message_bar}

  # pack widget .menu_fr
  pack append .menu_fr \
    .menu_fr.frame0 {top frame center fillx} \
    .menu_fr.message0 {top frame w expand fillx} 

  # pack widget .
  pack append . \
    .menu_fr {top frame w fillx} \
    .fr_entries {top frame center fillx} \
    .frame2 {top frame w} \
    .frame3 {top frame w} 

  if {"[info procs XFEdit]" != ""} {
    XFEditSetShowWindows
    XFMiscBindWidgetTree .xfEdit
  }

  #.fr_entries.fr_comp_seq.e insert end {V L T}
  #.fr_entries.fr_date.e insert end {950313}
  #.fr_entries.fr_model.e insert end {L43D}
  #.fr_entries.fr_owner.e insert end {SCEC}
  #.fr_entries.fr_sens_pre.e insert end {}
  #.fr_entries.fr_ser_seq.e insert end {}
  #.fr_entries.fr_site_seq.e insert end {}


}


# User defined procedures


# Procedure: build_components_menu
proc build_components_menu { mymenu} {
  #set comp_list [ list {{V.P L.P T.P V.N L.N T.N}} {{V L T}} {V}]
  #foreach comp $comp_list {
  #  $mymenu add command #    -command [ format "set comp_seq %s" $comp ]  #    -label $comp 
  #}
  $mymenu add command -command {set comp_seq {V.P V.N L.P L.N T.P T.N}}  -label {V.P V.N L.P L.N T.P T.N}
  $mymenu add command -command {set comp_seq {V.P L.P T.P V.N L.N T.N}}  -label {V.P L.P T.P V.N L.N T.N}
  $mymenu add command -command {set comp_seq {V L T}}  -label {V L T}
  $mymenu add command -command {set comp_seq {V.P V.N}}  -label {V.P V.N}
  $mymenu add command -command {set comp_seq {H.P H.N}}  -label {H.P H.N}
  $mymenu add command -command {set comp_seq {H}}  -label {H}
  $mymenu add command -command {set comp_seq {V}}  -label {V}
}


# Procedure: build_lnlist
proc build_lnlist {} {
# need to generate the required file lnlist

  global comp_seq respname_date 
  global sens_mod sens_own sens_pre
  global sens_site_seq sens_ser_seq

  #put_msg "my build lnlist proc for respname"

  set file_list [ eval list [ glob *.*.*.* ] ]
  set file_len [ llength $file_list ]
  #puts "file_list length $file_len"

  set site_list [ eval list $sens_site_seq ]
  set site_len [ llength $site_list ]
  #puts [ format "site_list length %d" $site_len]

  set ser_list [ eval list $sens_ser_seq ]
  set ser_len [ llength $ser_list ]
  #puts [ format "ser_list length %d" $ser_len]

  set mod_list [ eval list $sens_mod ]
  set mod_len [ llength $mod_list ]

  set own_list [ eval list $sens_own ]
  set own_len [ llength $own_list ]

  set comp_list [ eval list $comp_seq ]
  set comp_len [ llength $comp_list ]
  #puts [ format "comp_list length %d" $comp_len]

  # check on number of files vs. serial and component info
  if { $file_len != [ expr $ser_len * $comp_len ] } {
    set str [ format "file_len (%d) != ser_len (%d) * comp_len (%d)" $file_len $ser_len $comp_len]
    put_msg $str 
    return
  }

  if { $site_len < 1 } {
    put_msg "no site entry(s) listed"
    return
  }

  # check if any of the required variables are empty
  if { $site_len > 1 } {
    if { $ser_len != $site_len } {
      put_msg "number of serial numbers does not match sites"
      return
    } 
  } 

  set pre $sens_pre
  # loop on serial numbers
  put_msg "building lnlist ..."
  #exec rm -f lnlist
  set fo [ open lnlist w ]
  set fo2 [ open ordered_list w ]
  for { set i 0 } { $i < $ser_len } { incr i } {
    set ser [ lindex $ser_list $i ]
    set site [ lindex $site_list [ expr { ( $site_len > 1 ) ? $i : 0 } ] ]
    set mod [ lindex $mod_list [ expr { ( $mod_len > 1 ) ? $i : 0 } ] ]
    set own [ lindex $own_list [ expr { ( $own_len > 1 ) ? $i : 0 } ] ]
    for { set j 0 } {$j < $comp_len } { incr j } {
      set comp [ lindex $comp_list $j ]
      set file [ lindex $file_list [ expr { ( $i * $comp_len) + $j}]]
      set nfile "$respname_date.$site.$own.$mod.$pre$ser.$comp"
      puts $fo "ln -s $file $nfile"
      puts $fo2 "$nfile.sac"
    }
  }
  close $fo
  close $fo2
  exec chmod +x lnlist
  put_msg "building lnlist ... done"
}


# Procedure: build_model_menu
proc build_model_menu { mymenu} {
  set model_list [ list L43D L4C3D L4 L22 L22E L28LBH L28BH L28B L1B L15LA GS13 S13 ]
  foreach model $model_list {
    #$mymenu add command -command [ format "set sens_mod %s" $model]  -label $model
    $mymenu add command -command [ format "append sens_mod %s; append sens_mod { }" $model ]  -label $model
  }
}


# Procedure: build_owner_menu
proc build_owner_menu { mymenu} {
  global sens_own
  set owner_list [ list SCEC PSCL UTEP UCLA UCSB USC CIT USGS ]
  foreach owner $owner_list {
    #$mymenu add command -command [ format "set sens_own %s" $owner]  -label $owner
    $mymenu add command -command [ format "append sens_own %s; append sens_own { }" $owner ]  -label $owner
  }
}


# Procedure: cleanup_done
proc cleanup_done {} {
  global xfShowWindow.top1
  global rm_file
  set xfShowWindow.top1 0
  destroy .top1
  set rm_file {}
}


# Procedure: cleanup_show
proc cleanup_show {} {
 # use this to call up top1
  global xfShowWindow.top1
  set xfShowWindow.top1 1
  ShowWindow.top1

  load_listing .top1.frame4.listbox8
}
proc load_listing { mylb} {
  # load up the listbox
  $mylb delete 0 [ $mylb size ]

  set file_list [ eval list [ glob -nocomplain *.*.*.* ]]
  #foreach file $file_list 

  for { set i 0 } { $i < [ llength $file_list ]} { incr i} {
    set str [ format  "%d   %s" [expr {$i+1}] [ lindex $file_list $i ]]
    $mylb insert end $str 
  }
}


# Procedure: help_done
proc help_done { args} {
  # need to destroy the tool here
  global xfShowWindow.top0
  set xfShowWindow.top0 0
  destroy .top0
}


# Procedure: help_show
proc help_show { args} {
  global xfShowWindow.top0
  set xfShowWindow.top0 1
  ShowWindow.top0
}


# Procedure: EndSrc
proc EndSrc {} {
  # Init my wierd strings etc
  init_my_vars

  # put all local procs to be run here
  build_owner_menu .menu_fr.frame0.menubutton1.m
  build_model_menu .menu_fr.frame0.menubutton2.m
  build_components_menu .menu_fr.frame0.menubutton3.m
}

proc init_my_vars {} {
  global {comp_seq}
  global {respname_date}
  global {sens_mod}
  global {sens_own}
  global {sens_pre}
  global {sens_ser_seq}
  global {sens_site_seq}

  set {comp_seq} {V L T}
  # set respname_date from current dir if possible

  set dnlist [split [ pwd ] / ]  
  set dirstr [lindex $dnlist [ expr { [ llength $dnlist ] - 1 } ] ]
  set str [ string range $dirstr 0 5 ]

  # if its not all numerical use old method
  if { [ regexp {^[0-9]+$} $str ] } {
    set {respname_date} $str
  } else {
    set {respname_date} [ exec date +%y%m%d ] 
  }

  set {sens_mod} {}
  set {sens_own} {}
  set {sens_pre} {}
  set {sens_ser_seq} {}
  set {sens_site_seq} {}
}

# Procedure: put_msg
proc put_msg { string} {
  global message_bar

  #puts stdout $string
  set message_bar $string
}

proc set_rm_file { file} {
  global rm_file

  set rm_file $file
}
proc remove_prob_record { args} {
  global rm_file

  set lb .top1.frame4.listbox8

  set mylist [ $lb curselection ]

  # new method, allow removal or more than one at a time
  foreach i $mylist {
    set entry [ $lb get $i ] 
    set file [ string trim [ string range $entry 3 end ] ] 
    $lb delete $i
    $lb insert $i [ expr { $i + 1 } ]
    #puts "index $i, file to remove $file"
    exec rm $file
  }

  # rm_file is last selected file
  # the following line is to strip off any ??? characters ???
  #set rmlist [ split $rm_file {\{\} }]
  #set file [ lindex $rmlist [expr {[llength $rmlist] -2}]]
  #set numb [ lindex $rmlist 1 ]
  #set indx [expr {[ lindex $rmlist 1 ]-1}]
  #$lb delete $indx
  #$lb insert $indx $numb
  #exec rm $file
}

# Procedure: quit_respname
proc quit_respname {} {
# test procedure
# need to generate the required file lnlist

# build_lnlist
exit 0
}


# Internal procedures


# Procedure: Alias
proc Alias { args} {
# xf ignore me 7
##########
# Procedure: Alias
# Description: establish an alias for a procedure
# Arguments: args - no argument means that a list of all aliases
#                   is returned. Otherwise the first parameter is
#                   the alias name, and the second parameter is
#                   the procedure that is aliased.
# Returns: nothing, the command that is bound to the alias or a
#          list of all aliases - command pairs. 
# Sideeffects: internalAliasList is updated, and the alias
#              proc is inserted
##########
  global internalAliasList

  if {[llength $args] == 0} {
    return $internalAliasList
  } {
    if {[llength $args] == 1} {
      set xfTmpIndex [lsearch $internalAliasList "[lindex $args 0] *"]
      if {$xfTmpIndex != -1} {
        return [lindex [lindex $internalAliasList $xfTmpIndex] 1]
      }
    } {
      if {[llength $args] == 2} {
        eval "proc [lindex $args 0] {args} {#xf ignore me 4
return \[eval \"[lindex $args 1] \$args\"\]}"
        set xfTmpIndex [lsearch $internalAliasList "[lindex $args 0] *"]
        if {$xfTmpIndex != -1} {
          set internalAliasList [lreplace $internalAliasList $xfTmpIndex $xfTmpIndex "[lindex $args 0] [lindex $args 1]"]
        } {
          lappend internalAliasList "[lindex $args 0] [lindex $args 1]"
        }
      } {
        error "Alias: wrong number or args: $args"
      }
    }
  }
}


# Procedure: GetSelection
if {"[info procs GetSelection]" == ""} {
proc GetSelection {} {
# xf ignore me 7
##########
# Procedure: GetSelection
# Description: get current selection
# Arguments: none
# Returns: none
# Sideeffects: none
##########

  # the save way
  set xfSelection ""
  catch "selection get" xfSelection
  if {"$xfSelection" == "selection doesn't exist or form \"STRING\" not defined"} {
    return ""
  } {
    return $xfSelection
  }
}
}


# Procedure: MenuPopupAdd
if {"[info procs MenuPopupAdd]" == ""} {
proc MenuPopupAdd { xfW xfButton xfMenu {xfModifier ""} {xfCanvasTag ""}} {
# xf ignore me 7
# the popup menu handling is from (I already gave up with popup handling :-):
#
# Copyright 1991,1992 by James Noble.
# Everyone is granted permission to copy, modify and redistribute.
# This notice must be preserved on all copies or derivates.
#
##########
# Procedure: MenuPopupAdd
# Description: attach a popup menu to widget
# Arguments: xfW - the widget
#            xfButton - the button we use
#            xfMenu - the menu to attach
#            {xfModifier} - a optional modifier
#            {xfCanvasTag} - a canvas tagOrId
# Returns: none
# Sideeffects: none
##########

  if {"$xfModifier" != ""} {
    set xfPressModifier "$xfModifier-"
    set xfMoveModifier "$xfModifier-"
    set xfReleaseModifier "Any-"
  } {
    set xfPressModifier ""
    set xfMoveModifier ""
    set xfReleaseModifier ""
  }

  if {"$xfCanvasTag" == ""} {
    if {[catch "bind $xfW \"<${xfPressModifier}ButtonPress-$xfButton>\"  \"$xfMenu post %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    if {[catch "bind $xfW \"<${xfMoveModifier}B$xfButton-Motion>\"  \"MenuPopupHandle $xfMenu %W %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    # we need these to counteract the effects of passive grabs :-(
    if {[catch "bind $xfW \"<${xfReleaseModifier}ButtonRelease-$xfButton>\"  \"$xfMenu invoke active; $xfMenu unpost\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
  } {
    if {[catch "$xfW bind $xfCanvasTag \"<${xfPressModifier}ButtonPress-$xfButton>\"  \"$xfMenu post %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    if {[catch "$xfW bind $xfCanvasTag \"<${xfMoveModifier}B$xfButton-Motion>\"  \"MenuPopupHandle $xfMenu %W %X %Y\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
    # we need these to counteract the effects of passive grabs :-(
    if {[catch "$xfW bind $xfCanvasTag \"<${xfReleaseModifier}ButtonRelease-$xfButton>\"  \"$xfMenu invoke active; $xfMenu unpost\"" xfResult]} {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "$xfResult"
      } {
        puts stdout "$xfResult"
      }
      return
    }
  }
}
}


# Procedure: MenuPopupHandle
if {"[info procs MenuPopupHandle]" == ""} {
proc MenuPopupHandle { xfMenu xfW xfX xfY} {
# xf ignore me 7
##########
# Procedure: MenuPopupHandle
# Description: handle the popup menus
# Arguments: xfMenu - the menu to attach
#            xfW - the widget
#            xfX - the root x coordinate
#            xfY - the root x coordinate
# Returns: none
# Sideeffects: none
##########

  if {"[info commands $xfMenu]" != "" && [winfo ismapped $xfMenu]} {
    set xfPopMinX [winfo rootx $xfMenu]
    set xfPopMaxX [expr $xfPopMinX+[winfo width $xfMenu]]
    if {($xfX >= $xfPopMinX) &&  ($xfX <= $xfPopMaxX)} {
      $xfMenu activate @[expr $xfY-[winfo rooty $xfMenu]]
    } {
      $xfMenu activate none
    }
  }
}
}


# Procedure: NoFunction
if {"[info procs NoFunction]" == ""} {
proc NoFunction { args} {
# xf ignore me 7
##########
# Procedure: NoFunction
# Description: do nothing (especially with scales and scrollbars)
# Arguments: args - a number of ignored parameters
# Returns: none
# Sideeffects: none
##########
}
}


# Procedure: SN
if {"[info procs SN]" == ""} {
proc SN { {xfName ""}} {
# xf ignore me 7
##########
# Procedure: SN
# Description: map a symbolic name to the widget path
# Arguments: xfName
# Returns: the symbolic name
# Sideeffects: none
##########

  SymbolicName $xfName
}
}


# Procedure: SymbolicName
if {"[info procs SymbolicName]" == ""} {
proc SymbolicName { {xfName ""}} {
# xf ignore me 7
##########
# Procedure: SymbolicName
# Description: map a symbolic name to the widget path
# Arguments: xfName
# Returns: the symbolic name
# Sideeffects: none
##########

  global symbolicName

  if {"$xfName" != ""} {
    set xfArrayName ""
    append xfArrayName symbolicName ( $xfName )
    if {![catch "set \"$xfArrayName\"" xfValue]} {
      return $xfValue
    } {
      if {"[info commands XFProcError]" != ""} {
        XFProcError "Unknown symbolic name:\n$xfName"
      } {
        puts stderr "XF error: unknown symbolic name:\n$xfName"
      }
    }
  }
  return ""
}
}


# Procedure: Unalias
proc Unalias { aliasName} {
# xf ignore me 7
##########
# Procedure: Unalias
# Description: remove an alias for a procedure
# Arguments: aliasName - the alias name to remove
# Returns: none
# Sideeffects: internalAliasList is updated, and the alias
#              proc is removed
##########
  global internalAliasList

  set xfIndex [lsearch $internalAliasList "$aliasName *"]
  if {$xfIndex != -1} {
    rename $aliasName ""
    set internalAliasList [lreplace $internalAliasList $xfIndex $xfIndex]
  }
}



# application parsing procedure
proc XFLocalParseAppDefs {xfAppDefFile} {
  global xfAppDefaults

  # basically from: Michael Moore
  if {[file exists $xfAppDefFile] &&
      [file readable $xfAppDefFile] &&
      "[file type $xfAppDefFile]" == "link"} {
    catch "file type $xfAppDefFile" xfType
    while {"$xfType" == "link"} {
      if {[catch "file readlink $xfAppDefFile" xfAppDefFile]} {
        return
      }
      catch "file type $xfAppDefFile" xfType
    }
  }
  if {!("$xfAppDefFile" != "" &&
        [file exists $xfAppDefFile] &&
        [file readable $xfAppDefFile] &&
        "[file type $xfAppDefFile]" == "file")} {
    return
  }
  if {![catch "open $xfAppDefFile r" xfResult]} {
    set xfAppFileContents [read $xfResult]
    close $xfResult
    foreach line [split $xfAppFileContents "\n"] {
      # backup indicates how far to backup.  It applies to the
      # situation where a resource name ends in . and when it
      # ends in *.  In the second case you want to keep the *
      # in the widget name for pattern matching, but you want
      # to get rid of the . if it is the end of the name. 
      set backup -2  
      set line [string trim $line]
      if {[string index $line 0] == "#" || "$line" == ""} {
        # skip comments and empty lines
        continue
      }
      set list [split $line ":"]
      set resource [string trim [lindex $list 0]]
      set i [string last "." $resource]
      set j [string last "*" $resource]
      if {$j > $i} { 
        set i $j
        set backup -1
      }
      incr i
      set name [string range $resource $i end]
      incr i $backup
      set widname [string range $resource 0 $i]
      set value [string trim [lindex $list 1]]
      if {"$widname" != "" && "$widname" != "*"} {
        # insert the widget and resourcename to the application
        # defaults list.
        set xfAppDefaults($widname:[string tolower $name]) $value
      }
    }
  }
}

# application loading procedure
proc XFLocalLoadAppDefs {xfClasses {xfPriority "startupFile"} {xfAppDefFile ""}} {
  global env

  if {"$xfAppDefFile" == ""} {
    set xfFileList ""
    if {[info exists env(XUSERFILESEARCHPATH)]} {
      append xfFileList [split $env(XUSERFILESEARCHPATH) :]
    }
    if {[info exists env(XAPPLRESDIR)]} {
      append xfFileList [split $env(XAPPLRESDIR) :]
    }
    if {[info exists env(XFILESEARCHPATH)]} {
      append xfFileList [split $env(XFILESEARCHPATH) :]
    }
    append xfFileList " /usr/lib/X11/app-defaults"
    append xfFileList " /usr/X11/lib/X11/app-defaults"

    foreach xfCounter1 $xfClasses {
      foreach xfCounter2 $xfFileList {
        set xfPathName $xfCounter2
        if {[regsub -all "%N" "$xfPathName" "$xfCounter1" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%T" "$xfPathName" "app-defaults" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%S" "$xfPathName" "" xfResult]} {
          set xfPathName $xfResult
        }
        if {[regsub -all "%C" "$xfPathName" "" xfResult]} {
          set xfPathName $xfResult
        }
        if {[file exists $xfPathName] &&
            [file readable $xfPathName] &&
            ("[file type $xfPathName]" == "file" ||
             "[file type $xfPathName]" == "link")} {
          catch "option readfile $xfPathName $xfPriority"
          if {"[info commands XFParseAppDefs]" != ""} {
            XFParseAppDefs $xfPathName
          } {
            if {"[info commands XFLocalParseAppDefs]" != ""} {
              XFLocalParseAppDefs $xfPathName
            }
          }
        } {
          if {[file exists $xfCounter2/$xfCounter1] &&
              [file readable $xfCounter2/$xfCounter1] &&
              ("[file type $xfCounter2/$xfCounter1]" == "file" ||
               "[file type $xfCounter2/$xfCounter1]" == "link")} {
            catch "option readfile $xfCounter2/$xfCounter1 $xfPriority"
            if {"[info commands XFParseAppDefs]" != ""} {
              XFParseAppDefs $xfCounter2/$xfCounter1
            } {
              if {"[info commands XFLocalParseAppDefs]" != ""} {
                XFLocalParseAppDefs $xfCounter2/$xfCounter1
              }
            }
          }
        }
      }
    }
  } {
    # load a specific application defaults file
    if {[file exists $xfAppDefFile] &&
        [file readable $xfAppDefFile] &&
        ("[file type $xfAppDefFile]" == "file" ||
         "[file type $xfAppDefFile]" == "link")} {
      catch "option readfile $xfAppDefFile $xfPriority"
      if {"[info commands XFParseAppDefs]" != ""} {
        XFParseAppDefs $xfAppDefFile
      } {
        if {"[info commands XFLocalParseAppDefs]" != ""} {
          XFLocalParseAppDefs $xfAppDefFile
        }
      }
    }
  }
}

# application setting procedure
proc XFLocalSetAppDefs {{xfWidgetPath "."}} {
  global xfAppDefaults

  if {![info exists xfAppDefaults]} {
    return
  }
  foreach xfCounter [array names xfAppDefaults] {
    if {[string match "${xfWidgetPath}*" $xfCounter]} {
      set widname [string range $xfCounter 0 [expr [string first : $xfCounter]-1]]
      set name [string range $xfCounter [expr [string first : $xfCounter]+1] end]
      # Now lets see how many tcl commands match the name
      # pattern specified.
      set widlist [info command $widname]
      if {"$widlist" != ""} {
        foreach widget $widlist {
          # make sure this command is a widget.
          if {![catch "winfo id $widget"]} {
            catch "$widget configure -[string tolower $name] $xfAppDefaults($xfCounter)" 
          }
        }
      }
    }
  }
}


# prepare auto loading
global auto_path
global tk_library
global xfLoadPath
set auto_path "[split $xfLoadPath :] $tk_library [info library]"

# initialize global variables
proc InitGlobals {} {
  global {message_bar}
  set {message_bar} {}
  global {comp_seq}
  set {respname_date} {} 
  global {sens_mod}
  set {sens_mod} {}
  global {sens_own}
  set {sens_own} {}
  global {sens_pre}
  set {sens_pre} {}
  global {sens_ser_seq}
  set {sens_ser_seq} {}
  global {sens_site_seq}
  set {sens_site_seq} {}

  # please don't modify the following
  # variables. They are needed by xf.
  global {autoLoadList}
  set {autoLoadList(respname.tcl)} {0}
  global {internalAliasList}
  set {internalAliasList} {}
  global {moduleList}
  set {moduleList(respname.tcl)} {}
  global {preloadList}
  set {preloadList(xfInternal)} {}
  global {symbolicName}
  set {symbolicName(Directory list)} {.menu_fr.listbox1}
  set {symbolicName(respname)} {.top0}
  set {symbolicName(root)} {.}
  global {xfWmSetPosition}
  set {xfWmSetPosition} {}
  global {xfWmSetSize}
  set {xfWmSetSize} {}
  global {xfAppDefToplevels}
  set {xfAppDefToplevels} {}
}

# initialize global variables
InitGlobals

# display/remove toplevel windows.
ShowWindow.

#global xfShowWindow.top0
#set xfShowWindow.top0 1
#ShowWindow.top0

#global xfShowWindow.top1
#set xfShowWindow.top1 1
#ShowWindow.top1

# load default bindings.
if {[info exists env(XF_BIND_FILE)] &&
    "[info procs XFShowHelp]" == ""} {
  source $env(XF_BIND_FILE)
}

# parse and apply application defaults.
XFLocalLoadAppDefs Respname
XFLocalSetAppDefs

EndSrc

# eof
#

