#include <stdio.h>
#include <math.h>
#include "resp_calc.h"
#define FALSE 0
#define TRUE  1

/* 
  The observed values can be obtained from id

  Fi is the input frequency to calculate the value for 
  Fo is the observed resonant frequency
  Gd is the loaded generator constant (with shunt resistor Rs)
  Do is the observed damping
*/
/* Gd unused */
float phase_shift(float Fi, float Fo, float Gd, float Do) {
  float out, t;

  t = atan(((2.0*Do*Fo*Fi)/((Fo*Fo)-(Fi*Fi))));
  /*
  t / 2*M_PI*f

  if(Fi <= Fo) out = 180.0 - ((180.0/M_PI)*t);
  else         out = -1.0*(180.0/M_PI)*t;

  */

  if(Fi <= Fo) out = (M_PI - t)/(2.0*M_PI*Fi);
  else         out = (-1.0 * t)/(2.0*M_PI*Fi);

  return(out);
}

/*
  03/09/94 PR noticed that the vel sensitivity plot had no
  overshoot.  When we checked the formula, we found that the
  Do term in the denominator was not squared.
*/
float vel_sensitivity(float   Fi, float   Fo, float   Gd, float   Do) {
  float Fi2, Fo2, out;

  Fi2 = Fi * Fi;
  Fo2 = Fo * Fo;

  out = (Gd*Fi2)/sqrt(((Fo2-Fi2)*(Fo2-Fi2))+(4.0*Do*Do*Fo2*Fi2));
  return(out);
}
/* Gd unused */
float
phase_delay(float   Fi, float   Fo, float   Gd, float   Do) {
  float out, t;

  if(Fo == Fi)  /* ?? */ return(90.0); 

  t = atan(((2.0*Do*Fo*Fi)/((Fo*Fo)-(Fi*Fi))));

  if(Fi <= Fo) out = 180.0 - ((180.0/M_PI)*t);
  else         out = -1.0*(180.0/M_PI)*t;

  return(out);
}
/* Gd unused */
float group_delay(float   Fi, float   Fo, float   Gd, float   Do) {
  float Fi2, Fo2, Fo3;
  float tmp, out;

  Fi2 = Fi * Fi;
  Fo2 = Fo *Fo ;
  tmp = (Fi2*Fi2)+(2*Fo2*Fi2*((2.0*(Do*Do))-1.0))+(Fo2*Fo2);
  out = (1.0/M_PI)* (((Fo*Do*Fi2)+(Fo2*Fo*Do))/tmp);

  return(out);
}
