#include <stdio.h>
#include <string.h>
#include "resp_input.h"

static RESPINFO *resp_input[TAB_MAX];
static RESPINFO  head, tail;
static int tabsize;

/* this reads in the table produced by id.csh */
/* currently, it does no error checking on values */
int read_id_table(char * file, int * maxlen) {
  register int i;
  FILE *fi;
  char buf[256];
  char tmp[256];
  RESPINFO *r;
  int len;

  if(!(fi=fopen(file,"r"))) syserr("opening file",file,1);

  for(i=0;fgets(buf,256,fi) && i<TAB_MAX ;i++){
    /* check for comments */
    if(buf[0] == '#' || buf[0] == '\n'){
      i--;
      continue;
    }
    /* allocate a struct */
    r = alloc_id_tab_entry();

    /* read line */
    sscanf(buf,"%s %f %f %f", tmp,&r->Tid,&r->Did,&r->GNid );
    r->file = strdup(tmp);
    if((len=strlen(r->file)) > *maxlen) *maxlen = len;
    resp_input[i] = r;
  }
  if(i>=TAB_MAX){
    /* filled struct */
  }

  fclose(fi);
  return((tabsize=i));
}

RESPINFO * get_id_tab_entry(int  num) {
  if(num < 0 || num > tabsize) return(NULL);
  return(resp_input[num]);
}
RESPINFO * alloc_id_tab_entry() {
  RESPINFO *rt;

  if(!(rt=(RESPINFO *) calloc(1,sizeof(RESPINFO))))
	  err("allocating memory","response_input",1);

  return(rt);
}

/* only want response to do entries that match the input args */
/* return index number if found, else -1 if not */
int do_id_table(char * file) {
  register int i;
  char *c, *s;

  /* this should strip off any ".idmod" suffix */
  if(s = strstr((c=strdup(file)),".idmod")) *s = NULL;

  for(i=0;i<tabsize;i++){
    if(!(strcmp(c,resp_input[i]->file))) return(i);
  }
  return(-1);
}
