#include <stdio.h>
#include <string.h>
#include "response.h"
#include "resp_info.h"
#define FO fprintf(fo
#define alog(a) ((a <= 0.0) ? 0.0 : log10(a))
#define ROWS 20
  
  /*
  static float col[] = { 0.00, 0.25, 1.75, 3.25, 4.90, 7.00  };
  */
  static float col[] = { 0.00, 0.25, 2.00, 3.75, 5.50, 7.00  };
  static float trow[] = { 1.30, 1.10, 0.80, 0.60, 0.40, 0.20, 0.0, -0.20  };
  static float tcol[] = { 0.0, 0.10, 0.20, 0.30, 0.40  };

  static float row[ROWS];
  static char pserr[256] = { "" };

int ps_labels(FILE * fo, RESPINFO * r) {
  register int i;
  static char V[128];
  static char U[128];
  RESPINFO *s;
  PSSTR *p;
  float y;
  float *C, *R, *TR, *TC;
  float rowh = 0.20;


  s = r; /* hack for now */
  p = r->psstr;

  /* generate even row heights */
  for(i=1,row[0] = 9.70;i<ROWS;i++) row[i] = row[i-1] - rowh;

  FO,"GS NP .5 I .5 I T\n");
  FO,"lgbfont 7.5 2 div I 10.0 I M (SCEC Sensor Calibration Sheet) SHC\n");

  R = row+0;
  C = col+0;
  FO,"smfont %.2f I %.2f I M (Date Measured:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%02d/%02d/%02d) VAL\n", s->month,s->day,s->year);
  C++;
  FO,"smfont %.2f I %.2f I M (At:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s) VAL\n", s->sit);
  if(comment){
    FO,"mdbfont %.2f I %.2f I M (Recorded with x1.5 LNM.  Amplitude) SHL\n",*C,*R);
    FO,"mdbfont %.2f I %.2f I M (correction accounted for in values) SHL\n",*C,*(R+1));
  }


  R++;
  C = col+0;
  FO,"smfont %.2f I %.2f I M (General Sensor Info (mfgr/calc/meas) -) SHL\n",*C++,*R);
  R++;
  C = col+1;
  FO,"smfont %.2f I %.2f I M (Model:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s) VAL\n",s->mod);
  FO,"smfont %.2f I %.2f I M (SN:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s) VAL\n",s->ser);
  FO,"smfont %.2f I %.2f I M (Comp:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s) VAL\n",s->cmp);
  FO,"smfont %.2f I %.2f I M (Property of:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s) VAL\n", s->own);

  R++;
  C = col+1;
  FO,"smfont %.2f I %.2f I M (R) ITEM (c) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Rcv);
  FO,"smsymb (\\127) VAL\n");
  FO,"smfont %.2f I %.2f I M (R) ITEM (deo) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n", p->Rdeov);
  FO,"smsymb (\\127 ) VAL\n");
  FO,"smfont %.2f I %.2f I M (R) ITEM (dsr1) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n", p->Rdsr1v);
  FO,"smsymb (\\127 ) VAL\n");
  FO,"smfont %.2f I %.2f I M (R) ITEM (dsr2) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n", p->Rdsr2v);
  FO,"smsymb (\\127 ) VAL\n");
  R++;
  C = col+1;
  FO,"smfont %.2f I %.2f I M (R) ITEM (meas) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Rmeasv);
  FO,"smsymb (\\127 ) VAL\n");
  FO,"smfont %.2f I %.2f I M (Mass:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Mmfgrv);
  FO,"smfont (%s) VAL ","Kg");
  FO,"smfont %.2f I %.2f I M (Atten:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Attenv);
  FO,"smfont (%s) VAL ","");
  FO,"smfont %.2f I %.2f I M (Iext:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%g ) VAL\n",r->Iext);
  FO,"smfont (mA) VAL ","");

  /* have room here for two more vals */

  R++;
  C = col+1;
  FO,"smfont %.2f I %.2f I M (F) ITEM (mfgr) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Fmfgrv);
  FO,"smfont (%s) VAL ","Hz");
  FO,"smfont %.2f I %.2f I M (D) ITEM (calc) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Dcalcv);
  FO,"smfont (%s) VAL ","% crit");
  FO,"smfont %.2f I %.2f I M (G) ITEM (mfgr) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Gmfgrv);
  FO,"smfont (%s) VAL ",p->Gmfgru);
  FO,"smfont %.2f I %.2f I M (G) ITEM (d) SS (:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",p->Gdv);
  FO,"smfont (%s) VAL ",p->Gdu);

  R++;
  C = col+0;
  FO,"smfont %.2f I %.2f I M (Measured Info (from llnlid) and info calculated from measured values- ) SHL ",*C++,*R);

  R++;
  C = col+1;
  FO,"smfont %.2f I %.2f I M ",*C++,*R);
  FO,"(F) ITEM (id) SS (:  ) ITEM mdbfont (%.3f ) VAL smfont (Hz) VAL\n",r->Fid);
  FO,"smfont %.2f I %.2f I M ",*C++,*R);
  FO,"(D) ITEM (id) SS (:  ) ITEM mdbfont (%.3f) VAL\n",r->Did);
  FO,"smfont (%s) VAL\n","% crit");

  FO,"smfont %.2f I %.2f I M ",*C++,*R);
  FO,"(G) ITEM (uid) SS (:  ) ITEM mdbfont (%s ) VAL\n",p->Guidv);
  FO,"smfont (%s) VAL\n",p->Guidu);
  FO,"smfont %.2f I %.2f I M ",*C++,*R);
  FO,"(G) ITEM (id) SS (:  ) ITEM mdbfont (%s ) VAL\n",p->Gidv);
  FO,"smfont (%s) VAL\n",p->Gidu);

  R++;
  C = col+1;
  FO,"smfont %.2f I %.2f I M ",*C++,*R);
  FO,"(GN) ITEM (id) SS (:  ) ITEM mdbfont (%.2f ) VAL\n",r->GNid);
  FO,"smfont () VAL\n");

#ifdef NEW
  FO,"smfont %.2f I %.2f I M (Zeroes:  ) ITEM ",*C++,*R);
  FO,"(%g) (%g) %g md_paz_show\n",r->paz[2].r,r->paz[2].i,r->Did);
  FO,"smfont (%s) VAL ","rad/s");

  FO,"smfont %.2f I %.2f I M (Poles:  ) ITEM ",*C++,*R);
  FO,"(%g) (%g) %g md_paz_show\n",r->paz[0].r,r->paz[0].i,r->Did);
  FO,"smfont (%s) VAL ","rad/s");

  C = col+1;
  R++;
#endif
  FO,"smfont %.2f I %.2f I M (Pulse pol:  ) ITEM ",*C++,*R);
  FO,"mdbfont (%s ) VAL\n",(r->pol)?r->pol:"NA");
  FO,"smfont (%s) VAL ","");

  R++;
  C = col;
  FO,"GS /txtproc { SCP1 } def mdfont\n");
  FO,"%.2f I %.2f I M ",*C++, *R);
  FO,"smfont (%s) VAL\n",pserr);
  FO,"GR\n");


  /* transfer instructions at bottom of page */
  TR = trow;
  TC = tcol;
  FO,"NP mdbfont %.2f I %.2f I M\n",*TC,*TR++);
  FO,"(Analytic transfer function: ) SHL\n");

  TC++;
  FO,"smfont %.2f I %.2f I M\n",*TC,*TR++);
  FO,"(Zeroes (rad/s): ) ITEM (%g) (%g) %g sm_paz_show\n",r->paz[2].r,r->paz[2].i,r->Did);
  FO,"(  Poles (rad/s): ) ITEM (%g) (%g) %g sm_paz_show\n",r->paz[0].r,r->paz[0].i,r->Did);
  FO,"(  Multiplicative Constant \\050G) ITEM (id) SS smfont (\\051: ) ITEM (%s (%s)) VAL\n",p->Gidv,p->Gdu);

  TC = tcol;
  FO,"NP mdbfont %.2f I %.2f I M\n",*TC,*TR++);
  FO,"(Deconvolving data from this sensor back to earth motion:) SHL\n");

  TC++;
  FO,"NP mdfont %.2f I %.2f I M\n",*TC,*TR++);
  FO,"(Using the TRANSFER subroutine in SAC: ) SHL\n");
  FO,"smfont ((from .2 to 30 Hz with taper outside that range)) SHL\n");

  TC++;
  TC++;
  /* format entire transfer sequence into a string to allow easy output */
  FO,"NP mdhelv %.2f I %.2f I M (transfer from general n) VAL\n",*TC, *TR++);
  FO,"mdbfont ( B ) VAL mdhelv\n"); 
  sprintf(V,"freeperiod %.3f m %s d %.3f to none freq .1 .2 30. 40.",
    r->Tid, p->Gv, r->Did);
  FO,"(%s) VAL\n",V);

  FO,"smfont %.2f I %.2f I M\n",*TC,*TR++);
  FO,"(Set ) SHL mdbfont (B) VAL smfont (=2 for velocity (m/s).  ) SHL\n");
  FO,"(Set ) SHL mdbfont (B) VAL smfont (=3 for displacement (m).) SHL\n");

  /* add in two lines at bottom for possible captions, use SCP0 defined color */
  FO,"GS /txtproc { SCP0 } def mdfont\n");
  FO,"7.5 2 div I %.2f I M () SHC\n",*TR++);
  FO,"7.5 2 div I %.2f I M () SHC\n",*TR++);
  FO,"GR\n");

  FO,"GR %% restore \n");

  sprintf(V,"%s %g %s %g %g (%g,+-%1s%g) (%g,+-%1s%g)%c",
    r->file,
    r->Tid,
    p->Gv,
    r->Did,
    r->Fid,
    r->paz[2].r, (r->Did <= 1.0)? "i":"", r->paz[2].i,
    r->paz[0].r, (r->Did <= 1.0)? "i":"", r->paz[0].i,
    NULL);
  fprintf(fout,"%s\n",V);
}
// load_pserr_str(str)
// char *str;
int
load_pserr_str(char * str)
{
  /* for now will append messages onto the string with colons */
  sprintf(pserr,"%s",str);
}
