/* used set char arrays to allow direct scanf reading into struct */

typedef struct resp_tab {
  int year, month, day;
  char owner[16]; /* Hopefully less than this */
  char site[16];  /* Testing site, Hopefully less than this */
  char model[16]; /* Sensor model, can be many lengths */
  char sn[8];     /* should be four chars */
  char comp[4];   /* component, should be single char */
  char pol[4];    /* polarity, should be single char */
  float Gn;       /* Gain from id (dimensionless for now) */
  float Do;       /* Observed Damping from id */
  float To;       /* Observed Period from id */
  float Fo;       /* Observed frequency, reciprocal of To */
  float Rc;       /* Coil resistance (measured) */
  float Gd;       /* Damped generator constant (v/m/s) */
  float Rd;       /* Damping resistance (measured) */

  float Rmfgr;    /* Coil resistance from mfgr ohms */ 
  float Fmfgr;    /* Manufacturers frequency, reciprocal of Tmfgr */
  float Tmfgr;    /* Manufacturers period, reciprocal of Fmfgr */
  float Mmfgr;    /* Manufacturers mass specification Kg */
  float Dmfgr;    /* Mfgr speced damping, open circuit, percent of critical */
  float Gmfgr;    /* Mfgr Generator constant, open circuit  V/m/s */

  float Dcalc;    /* Calculated damping, from mfgr specs and measured vals */
  float Isig;     /* Measured Current through signal coil milliamps? */ 
  float Rext;     /* External resistance setting controlling Isig, may not be needed ohms */
  float Rsone;    /* first series damping resistor UCLA design expected */
  float Rstwo;    /* second series damping resistor ohms */
  float Rmeas;    /* Measured resistance of entire sensor package with damping resistors ohms */ 
} RESPTAB;

#define TABLE_TAB_MAX 512

struct resp_tab *get_tab_entry(), *alloc_tab_entry();

#ifdef JUNK
#endif
