#!/bin/csh -f
# /local/ucsb/bin/newcsh
# created by aaron on 05/03/93
# csh to dump data from a floppy disk via pcfs
# mainly designed as a way to transfer response data
#
# -mv option moves the reftek data out of its R subdirs into the basedir
# -rm option removes the R subdirs
# -file option specifies that the input file is on disk, not floppy
# -floppy option specifies that the input file is on floppy
#
# If floppy fails, try from file?
#
#
set usage = "usage: $0 [-mv] [-rm] [-file] [-floppy] file ..."
set mv = 0
set rm = 0
set fromfloppy = 1
set split = 0

if( $#argv < 1 ) then
  echo "$usage"
  exit
endif 

set argc = 1
while( $argc <= $#argv )
  switch ( $argv[$argc] )
    case -mv :
      set mv = 1
      breaksw
    case -rm :
      set rm = 1
      set mv = 1
      breaksw
    case -split :
      @ argc++
      set split = "$argv[$argc]"
      breaksw
    case -file :
      set fromfloppy = 0
      breaksw
    case -floppy :
      set fromfloppy = 1
      breaksw
    case -* :
      echo "unrecognized arg $argv[$argc]"
      breaksw
    default :
      break
      breaksw
  endsw
  @ argc++
end

if( $fromfloppy ) mountfl

if ( $status ) then
  echo "error on mountfl, trying from the filesystem ..."
  set fromfloppy = 0
  #exit 1
endif

if ($split > 0) echo "split option not supported in csh version of dumpfl"

foreach dat ( $argv[$argc-$#argv] )
  # pull off any .dat suffix
  set input = `echo $dat | nawk -F"." '{print $1}'`

  # should check for existence of file and dir
  mkdir ${input}
  cd ${input}

  echo "copying specified data file ..."

  if( $fromfloppy ) then
    cp /pcfs/${input}.dat .
  else
    cp ../${input}.dat .
  endif

  ref2segy -f ${input}.dat 
  if( $mv ) mv R*/*.*.* .
  if( $rm ) rmdir R*

  cd ..
end

if ( $fromfloppy ) then
  umountfl
  eject
endif

/bin/rm -f /tmp/*.$$
exit 0
